<?php
/**
 * @version		$Id: evaluation.php,v 1.12 2012-01-18 17:08:13 juanca Exp $
 * @package		vpl. submission evaluation
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once dirname(__FILE__).'/../../../config.php';
require_once dirname(__FILE__).'/../locallib.php';
require_once dirname(__FILE__).'/../vpl.class.php';
require_once dirname(__FILE__).'/../vpl_submission_CE.class.php';

$id = required_param('id',PARAM_INT);
$vpl = new mod_vpl($id);
$userid = optional_param('userid',FALSE,PARAM_INT);
if((!$userid || $userid == $USER->id)
    && $vpl->get_instance()->evaluate){//Evaluate own submission
	$userid = $USER->id;
	$vpl->require_capability(VPL_SUBMIT_CAPABILITY);
}else { //Evaluate other user submission
	$vpl->require_capability(VPL_GRADE_CAPABILITY);
}
if($USER->id == $userid){
	$vpl->network_check();
	$vpl->password_check();
}
//Display page
$vpl->print_header(get_string('evaluation',VPL));
flush();
$course = $vpl->get_course();
$instance = $vpl->get_instance();
$vpl->add_to_log('evaluate', vpl_rel_url('forms/evaluation.php','id',$id,'userid',$userid));
$submission_instance=$vpl->last_user_submission($userid);
if($submission_instance === false){
	print_error('vpl_submission not found');
}else{
	$submission=new mod_vpl_submission_CE($vpl,$submission_instance);
	try{
		$submission->evaluate(false);
	}catch(Exception $e){
		print_box($e->getMessage());
		flush();
		usleep(5000000);
	}
}
if(optional_param('grading',0,PARAM_INT)){
	$inpopup = optional_param('inpopup',0,PARAM_INT);
	vpl_inmediate_redirect(vpl_mod_href('forms/gradesubmission.php','id',$id,'userid',$userid,'inpopup',$inpopup));
}else{
	redirect(vpl_mod_href('forms/submissionview.php','id',$id,'userid',$userid),'',2);	
}
$vpl->print_footer();
?>
