<?php
/**
 * @version		$Id: mod_form.php,v 1.27 2012-01-18 16:52:43 juanca Exp $
 * @package		vpl. vpl instance form
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once $CFG->dirroot.'/course/moodleform_mod.php';
require_once dirname(__FILE__).'/lib.php';
require_once dirname(__FILE__).'/vpl.class.php';

class mod_vpl_mod_form extends moodleform_mod {
	function definition(){
		global $CFG;
		$mform = & $this->_form;
        $mform->addElement('header', 'general', get_string('general', 'form'));
        // name
        $modname= 'vpl';
        $mform->addElement('text', 'name', get_string('name'), array('size'=>'50'));
        $mform->setType('name', PARAM_TEXT);
        $mform->addRule('name', null, 'required', null, 'client');
        $mform->applyFilter('name','trim');
        // shortdescription
        $mform->addElement('htmleditor', 'shortdescription', get_string('shortdescription',VPL), array('cols'=>50, 'rows'=>7));
        $mform->setType('shortdescription', PARAM_RAW);
        //$mform->addRule('shortdescription', null, null, null, 'client');
        //No 2.0 available
        //$mform->setHelpButton('shortdescription', array('writing', 'richtext'), false, 'editorhelpbutton');
        // submission period
        //TODO make from text
        $mform->addElement('header', 'submissionperiod', get_string('submissionperiod', VPL));
        $secondsday=24*60*60;
        $now = time();
        $inittime = round($now / $secondsday) * $secondsday+5*60;
        $endtime = $inittime + (8*$secondsday) - 5*60;
        // visiblefrom
        $mform->addElement('date_time_selector', 'visiblefrom', get_string('visiblefrom', VPL), array('optional'=>true));
        $mform->setDefault('visiblefrom', $inittime);
		$mform->setDefault('visiblefrom', 0);
		$mform->setAdvanced('visiblefrom');
        // availablefrom
        $mform->addElement('date_time_selector', 'availablefrom', get_string('availablefrom', VPL), array('optional'=>true));
        $mform->setDefault('availablefrom', $inittime);
		$mform->setDefault('availablefrom', 0);
        $mform->setAdvanced('availablefrom');
        // duedate
        $mform->addElement('date_time_selector', 'duedate', get_string('duedate', VPL), array('optional'=>true));
        $mform->setDefault('duedate', $endtime);
        // maxfiles
        $mform->addElement('header', 'submissionrestrictions', get_string('submissionrestrictions', VPL));
        $mform->addElement('text', 'maxfiles', get_string('maxfiles',VPL),array('size'=>'2'));
        $mform->setType('maxfiles', PARAM_INT);
        $mform->setDefault('maxfiles', 1);
        $mform->addElement('selectyesno', 'restrictededitor', get_string('restrictededitor',VPL));
        $mform->setDefault('restrictededitor', false);
        $mform->setAdvanced('restrictededitor');
        $mform->addElement('selectyesno', 'example', get_string('isexample',VPL));
        $mform->setDefault('example', false);
        $mform->setAdvanced('example');
        $max = vpl_get_max_post_size();
		if($CFG->vpl_maxfilesize > 0 && $CFG->vpl_maxfilesize < $max){
			$max = $CFG->vpl_maxfilesize;
		}
        $mform->addElement('select', 'maxfilesize', get_string('maxfilesize',VPL),
        					vpl_get_select_sizes($max));
        $mform->setType('maxfilesize', PARAM_INT);
        $mform->setDefault('maxfilesize', 0);
        $mform->setAdvanced('maxfilesize');
        $mform->addElement('passwordunmask', 'password', get_string('password'));
        $mform->setType('password', PARAM_TEXT);
        $mform->setAdvanced('password');
        $mform->addElement('text', 'requirednet', get_string('requirednet',VPL),array('size'=>'60'));
        $mform->setType('requirednet', PARAM_TEXT);
        $mform->setDefault('requirednet', '');
        $mform->setAdvanced('requirednet');
        // grade
        $mform->addElement('header', 'grading', get_string('gradeoptions', VPL));
        $mform->addElement('modgrade', 'grade', get_string('grade'));
        $mform->setDefault('grade', 100);
        $mform->addElement('selectyesno', 'visiblegrade', get_string('visiblegrade',VPL));
        $mform->setDefault('visiblegrade', 1);
        
        //Standard course elements
        $features = new stdClass;
        $features->groups = true;
        $features->groupings = true;
        $features->groupmembersonly = true;
        $this->standard_coursemodule_elements($features);
        // end form
        $this->add_action_buttons();
	}
	function display(){
		$id = optional_param('update',FALSE,PARAM_INT);
		if($id){
			$vpl = new mod_vpl($id);
			$vpl->print_configure_tabs('edit');
		}
		parent::display();
	}
}
?>
