<?php 
/**
 * @version		$Id: previoussubmissionslist.php,v 1.7 2012-05-07 10:22:22 juanca Exp $
 * @package		vpl. List previous submissions for a vpl and user
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once dirname(__FILE__).'/../../../config.php';
require_once dirname(__FILE__).'/../locallib.php';
require_once dirname(__FILE__).'/../vpl.class.php';
require_once dirname(__FILE__).'/../vpl_submission.class.php';
$id = required_param('id', PARAM_INT);
$userid = required_param('userid', PARAM_INT);
$detailed = optional_param('detailed', 0, PARAM_INT);
$vpl = new mod_vpl($id);
$course = $vpl->get_course();
$vpl->require_capability(VPL_GRADE_CAPABILITY);
$vpl->add_to_log('view previous', vpl_rel_url('previoussubmissionslist.php','id',$id,'userid',$userid));
//Load strings
$strdatesubmitted		= get_string('datesubmitted',VPL);
$strdescription			= get_string('description',VPL);
if($detailed){
	global $CFG;
	$CFG->stylesheets[] = vpl_mod_href('css/sh.css');
}
//Print header
$vpl->print_header(get_string('previoussubmissionslist',VPL));
$vpl->print_view_tabs(basename(__FILE__));

$table->head  = array ('#',$strdatesubmitted, $strdescription);
$table->align = array ('right','left', 'right');
$table->nowrap = array (true,true,true);
$submissionslist = $vpl->user_submissions($userid);
$submissions = array();
if($submissionslist){
	$nsub = count($submissionslist);
	foreach ($submissionslist as $submission) {
		if($detailed){
			$link = '#f'.$nsub;
		}else{
			$link = vpl_mod_href('forms/submissionview.php','id',$id,'userid',$userid,'submissionid',$submission->id);
		}
		$date = '<a href="'.$link.'">'.userdate($submission->datesubmitted).'</a>';
		$sub = new mod_vpl_submission($vpl,$submission);
		$submissions[] = $sub;
		$table->data[] = array ($nsub--,
								$date,
								s($sub->get_detail()));
	}
}
echo '<div class="clearer"> </div>';
echo '<div style="text-align: center">';
echo '<img src="'.vpl_rel_url('submissionsgraph.php','id',$id,'userid',$userid).'" alt="files size evolution" />';
echo '</div>';
echo '<div class="clearer"> </div>';
echo '<div class="clearer"> </div>';
echo '<div style="text-align: center">';
echo '<img src="'.vpl_rel_url('workinggraph.php','id',$id,'userid',$userid).'" alt="workingperiods" />';
echo '</div>';
echo '<div class="clearer"> </div>';
print_table($table);
echo '<div style="text-align:center">';
popup_form(vpl_mod_href('views/previoussubmissionslist.php','id',$id,'userid',$userid).'&amp;detailed=',
		array('0' => get_string('detailedless'), '1' => get_string('detailedmore')),
		'detailmenu',
		$detailed, '', '', '', false, 'self', get_string('view'));
echo '</div>';
if($detailed){
	$nsub = count($submissionslist);
	foreach ($submissions as $index => $sub) {
		echo '<hr><h2><a name="f'.$nsub.'"># '.$nsub.'</a></h2>';
		
		$nsub--;
		$sub->print_submission();
	}
}
$vpl->print_footer();

?>